#include "predef.h"
#include <stdio.h>
#include <ctype.h>
#include <startnet.h>
#include <serial.h>
#include <string.h>
#include <tcp.h>
#include <autoupdate.h>
#include <dhcpclient.h>
#include <netinterface.h>
#include <taskmon.h>

extern "C" {
void UserMain(void * pd);
}

const char * AppName="JavaClientTCP Example";

static DWORD   JavaDataStk[USER_TASK_STK_SIZE] __attribute__( ( aligned( 4 ) ) );
VDWORD Secs;   //Holds the number of seconds the NetBurner Module has been running

/*-------------------------------------------------------------------
Converts IP address ia to string s
 ------------------------------------------------------------------*/
void IPtoString(IPADDR  ia, char *s) {
	PBYTE ipb= (PBYTE)&ia;
	siprintf(s, "%d.%d.%d.%d",(int)ipb[0],(int)ipb[1],(int)ipb[2],(int)ipb[3]);
}

/*-------------------------------------------------------------------
 JavaDataTask creates a multi-client Server that streams data
 ------------------------------------------------------------------*/
void JavaDataTask( void *pd ){
   #define MAX_SOCKS (5)      //Max amount of connected clients
   int Listen_Socket = listen( 0, (WORD)(DWORD) pd );  //Set up the TCP listen socket
   int socket_list[MAX_SOCKS];   //array of to store client sockets
   int i;
   IPADDR MyIP;                //Stores IP address of client who is recieving data
   IPADDR ConnectedIP;         //Stores IP of other connected clients
   char MyIPstr[20];           //String IP address of client who is recieving data
   char ConnectedIPstr[20];    //String IP of other connected clients
   WORD MyPort;                //Incoming port of client who is recieving data
   WORD ConnectedPort;         //Incoming port of other connected clients
   char out_buff[120];         //Output buffer
   for ( i = 0; i < MAX_SOCKS; i++ ) //initializes the array of client sockets to 0
      socket_list[i] = 0;
   while ( 1 ) {
      OSTimeDly( 2 );
      for ( i = 0; i < MAX_SOCKS; i++ ) { /* Send data to each connected socket */
         if ( socket_list[i] ) {
            sprintf( out_buff, "The NetBurner Server has been running for %ld Seconds. zz" ,Secs);
            int rv = writestring( socket_list[i], out_buff );
            if ( rv <= 0 ) {  //if send failed then socket must be closed
               close( socket_list[i] );
               socket_list[i] = 0;
            }
            else {
               MyIP = GetSocketRemoteAddr(socket_list[i]);
               MyPort = GetSocketRemotePort(socket_list[i]);
               IPtoString(MyIP, MyIPstr);
               sprintf( out_buff, "You Are Currently Connected Through IP: %s:%d zz", MyIPstr, MyPort);
               writestring( socket_list[i], out_buff );
               sprintf( out_buff, "The Following Addresses Are Also Connected To The Server: zz");
               writestring( socket_list[i], out_buff );
               for(int j=0; j < MAX_SOCKS; j++ ){  //Send list of all connected clients
                  if((i!=j) && (socket_list[j]!=0)){
                     ConnectedIP = GetSocketRemoteAddr(socket_list[j]);
                     ConnectedPort = GetSocketRemotePort(socket_list[j]);
                     IPtoString(ConnectedIP, ConnectedIPstr);
                     sprintf( out_buff, "Connection %d IP: %s:%d zz",(j+1) ,ConnectedIPstr ,ConnectedPort);
                     writestring( socket_list[i], out_buff );
                  }
               }
               sprintf( out_buff, "\r\n");  //allows applet to read all streaming data with readLine()
               writestring( socket_list[i], out_buff );
            }
         }
      }
      while ( dataavail( Listen_Socket ) ) {  //Detects clients trying to connect and assigns them sockets
         int sock = accept( Listen_Socket, NULL, NULL, 20 );
         if ( sock > 0 ) {
            iprintf( "Accepted connection" );
            for ( i = 0; i < MAX_SOCKS; i++ ) {
               if ( socket_list[i] == 0 ) {
                  socket_list[i] = sock;
                  break;
               }
            }
            if ( i == MAX_SOCKS ) {   //If # of clients is > than MAX_SOCKS then remove newest client
               iprintf( "Error: Too many connections to the server\r\n" );
               sprintf( out_buff, "Error: Too many connections to the server\r\n");
               writestring( sock, out_buff );
               close( sock );
            }
         }
      }
   } // while (1)
}

/*-------------------------------------------------------------------
 Java Data Feed Task: Creates java task. Example usage:
   InitializeJAVADataFeed(10000, MAIN_PRIO-1);
------------------------------------------------------------------*/

void InitializeJAVADataFeed( WORD port, int priority ) {
   OSTaskCreate( JavaDataTask,
                 ( void * ) (DWORD)port,
                 ( void * ) &JavaDataStk[USER_TASK_STK_SIZE],
                 ( void * ) JavaDataStk,
                 priority );
}

/*-------------------------------------------------------------------
 Java Task
 ------------------------------------------------------------------*/
void UserMain(void * pd){
   InitializeStack();
   int EthernetInterface = GetFirstInterface();  // Get first interface identifier
   InterfaceBlock *ib = GetInterFaceBlock( EthernetInterface );  // Get interface data

   if (ib->netIP == 0)  // Check IP address for 0.0.0.0, and use DHCP if necessary
   {
      iprintf( "\r\nNo static IP address set, attempting DHCP\r\n");
      if ( GetDHCPAddress() != DHCP_OK )
         iprintf("*** DHCP Failed \r\n");
      else
         iprintf( "DHCP IP Address: ");
   }
   else
      iprintf("Static IP Address: ");
   ShowIP(ib->netIP); iprintf("\r\n");
   OSChangePrio(MAIN_PRIO);
   EnableAutoUpdate();
   StartHTTP();
   InitializeJAVADataFeed( 10000, MAIN_PRIO - 1 );
   EnableTaskMonitor();

   iprintf("Application started");
   while (1)
      OSTimeDly(20);
}
